---
title: Grammar and types
slug: Web/JavaScript/Guide/Grammar_and_types
tags:
  - Guide
  - JavaScript
  - 'l10n:priority'
---
<div>{{jsSidebar("JavaScript Guide")}} {{PreviousNext("Web/JavaScript/Guide/Introduction", "Web/JavaScript/Guide/Control_flow_and_error_handling")}}</div>

<p class="summary">This chapter discusses JavaScript's basic grammar, variable declarations, data types and literals.</p>

<h2 id="Basics">Basics</h2>

<p>JavaScript borrows most of its syntax from Java, C, and C++, but it has also been influenced by Awk, Perl, and Python.</p>

<p>JavaScript is <strong>case-sensitive</strong> and uses the <strong>Unicode</strong> character set. For example, the word Früh (which means "early" in German) could be used as a variable name.</p>

<pre class="brush: js notranslate">let Früh = "foobar"</pre>

<p>But, the variable <code>früh</code> is not the same as <code>Früh</code> because JavaScript is case sensitive.</p>

<p>In JavaScript, instructions are called {{Glossary("Statement", "statements")}} and are separated by semicolons (;).</p>

<p>A semicolon is not necessary after a statement if it is written on its own line. But if more than one statement on a line is desired, then they <em>must</em> be separated by semicolons.</p>

<div class="notecard note">
<p>ECMAScript also has rules for automatic insertion of semicolons (<a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Automatic_semicolon_insertion">ASI</a>) to end statements. (For more information, see the detailed reference about JavaScript's <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar">lexical grammar</a>.)</p>
</div>

<p>It is considered best practice, however, to always write a semicolon after a statement, even when it is not strictly needed. This practice reduces the chances of bugs getting into the code.</p>

<p>The source text of JavaScript script gets scanned from left to right, and is converted into a sequence of input elements which are <em>tokens</em>, <em>control characters</em>, <em>line terminators</em>, <em>comments</em>, or {{glossary("whitespace")}}. (Spaces, tabs, and newline characters are considered whitespace.)</p>

<h2 id="Comments">Comments</h2>

<p>The syntax of <strong>comments</strong> is the same as in C++ and in many other languages:</p>

<pre class="brush: js notranslate">// a one line comment

/* this is a longer,
 * multi-line comment
 */

/* You can't, however, /* nest comments */ SyntaxError */
</pre>

<p>Comments behave like whitespace, and are discarded during script execution.</p>

<div class="notecard note">
<p><strong>Note</strong>: You might also see a third type of comment syntax at the start of some JavaScript files, which looks something like this: <code>#!/usr/bin/env node</code>.</p>

<p>This is called <strong>hashbang comment</strong> syntax, and is a special comment used to specify the path to a particular JavaScript engine that should execute the script. See <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Hashbang_comments">Hashbang comments</a> for more details.</p>
</div>

<h2 id="Declarations">Declarations</h2>

<p>JavaScript has three kinds of variable declarations.</p>

<dl>
 <dt>{{jsxref("Statements/var", "var")}}</dt>
 <dd>Declares a variable, optionally initializing it to a value.</dd>
 <dt>{{jsxref("Statements/let", "let")}}</dt>
 <dd>Declares a block-scoped, local variable, optionally initializing it to a value.</dd>
 <dt>{{jsxref("Statements/const", "const")}}</dt>
 <dd>Declares a block-scoped, read-only named constant.</dd>
</dl>

<h3 id="Variables">Variables</h3>

<p>You use variables as symbolic names for values in your application. The names of variables, called {{Glossary("Identifier", "identifiers")}}, conform to certain rules.</p>

<p>A JavaScript identifier must start with a letter, underscore (<code>_</code>), or dollar sign (<code>$</code>). Subsequent characters can also be digits (<code>0</code>–<code>9</code>).</p>

<p>Because JavaScript is case sensitive, letters include the characters "<code>A</code>" through "<code>Z</code>" (uppercase) as well as "<code>a</code>" through "<code>z</code>" (lowercase).</p>

<p>You can use most of ISO 8859-1 or Unicode letters such as <code>å</code> and <code>ü</code> in identifiers. (For more details, see <a href="https://mathiasbynens.be/notes/javascript-identifiers-es6">this blog post</a>.) You can also use the <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#String_literals">Unicode escape sequences</a> as characters in identifiers.</p>

<p>Some examples of legal names are <code>Number_hits</code>, <code>temp99</code>, <code>$credit</code>, and <code>_name</code>.</p>

<h3 id="Declaring_variables">Declaring variables</h3>

<p>You can declare a variable in two ways:</p>

<ul>
 <li>With the keyword {{jsxref("Statements/var", "var")}}. For example, <code>var x = 42</code>. This syntax can be used to declare both <strong>local</strong> and <strong>global</strong> variables, depending on the <em>execution context</em>.</li>
 <li>With the keyword {{jsxref("Statements/const", "const")}} or {{jsxref("Statements/let", "let")}}. For example, <code>let y = 13</code>. This syntax can be used to declare a block-scope local variable. (See <a href="#Variable_scope">Variable scope</a> below.)</li>
</ul>

<p>You can declare variables to unpack values from <a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Object_literals">Object Literals</a> using the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">Destructuring Assignment</a> syntax. For example, <code>let { bar } = foo</code>. This will create a variable named <code>bar</code> and assign to it the value corresponding to the key of the same name from our object <code>foo</code>.  </p>

<p>You can also assign a value to a variable For example, <code>x = 42</code>. This form creates an <strong><a href="/en-US/docs/Web/JavaScript/Reference/Statements/var#Description">undeclared global</a></strong> variable. It also generates a strict JavaScript warning. Undeclared global variables can often lead to unexpected behavior. Thus, it is discouraged to use undeclared global variables.</p>

<h3 id="Evaluating_variables">Evaluating variables</h3>

<p>A variable declared using the <code>var</code> or <code>let</code> statement with no assigned value specified has the value of {{jsxref("undefined")}}.</p>

<p>An attempt to access an undeclared variable results in a {{jsxref("ReferenceError")}} exception being thrown:</p>

<pre class="brush: js notranslate">var a;
console.log('The value of a is ' + a); // The value of a is undefined

console.log('The value of b is ' + b); // The value of b is undefined
var b;
// This one may puzzle you until you read 'Variable hoisting' below

console.log('The value of c is ' + c); // Uncaught ReferenceError: c is not defined

let x;
console.log('The value of x is ' + x); // The value of x is undefined

console.log('The value of y is ' + y); // Uncaught ReferenceError: y is not defined
let y; </pre>

<p>You can use <code>undefined</code> to determine whether a variable has a value. In the following code, the variable <code>input</code> is not assigned a value, and the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else">if</a></code> statement evaluates to <code>true</code>.</p>

<pre class="brush: js notranslate">var input;
if (input === undefined) {
  doThis();
} else {
  doThat();
}
</pre>

<p>The <code>undefined</code> value behaves as <code>false</code> when used in a boolean context. For example, the following code executes the function <code>myFunction</code> because the <code>myArray</code> element is <code>undefined</code>:</p>

<pre class="brush: js notranslate">var myArray = [];
if (!myArray[0]) myFunction();
</pre>

<p>The <code>undefined</code> value converts to <code>NaN</code> when used in numeric context.</p>

<pre class="brush: js notranslate">var a;
a + 2;  // Evaluates to NaN</pre>

<p>When you evaluate a {{jsxref("null")}} variable, the null value behaves as <code>0</code> in numeric contexts and as <code>false</code> in boolean contexts. For example:</p>

<pre class="brush: js notranslate">var n = null;
console.log(n * 32); // Will log 0 to the console
</pre>

<h3 id="Variable_scope">Variable scope</h3>

<p>When you declare a variable outside of any function, it is called a <em>global</em> variable, because it is available to any other code in the current document. When you declare a variable within a function, it is called a <em>local</em> variable, because it is available only within that function.</p>

<p>JavaScript before ECMAScript 2015 does not have <a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling#Block_statement">block statement</a> scope. Rather, a variable declared within a block is local to the <em>function (or global scope)</em> that the block resides within.</p>

<p>For example, the following code will log <code>5</code>, because the scope of <code>x</code> is the global context (or the function context if the code is part of a function). The scope of <code>x</code> is not limited to the immediate <code>if</code> statement block.</p>

<pre class="brush: js notranslate">if (true) {
  var x = 5;
}
console.log(x);  // x is 5
</pre>

<p>This behavior changes when using the <code>let</code> declaration (introduced in ECMAScript 2015).</p>

<pre class="brush: js notranslate">if (true) {
  let y = 5;
}
console.log(y);  // ReferenceError: y is not defined
</pre>

<h3 id="Variable_hoisting">Variable hoisting</h3>

<p>Another unusual thing about variables in JavaScript is that you can refer to a variable declared later, without getting an exception.</p>

<p>This concept is known as <strong>hoisting.</strong> Variables in JavaScript are, in a sense, "hoisted" (or "lifted") to the top of the function or statement. However, variables that are hoisted return a value of <code>undefined</code>. So even if you declare and initialize after you use or refer to this variable, it still returns <code>undefined</code>.</p>

<pre class="brush: js notranslate">/**
 * Example 1
 */
console.log(x === undefined); // true
var x = 3;

/**
 * Example 2
 */
// will return a value of undefined
var myvar = 'my value';

(function() {
  console.log(myvar); // undefined
  var myvar = 'local value';
})();
</pre>

<p>The above examples will be interpreted the same as:</p>

<pre class="brush: js notranslate">/**
 * Example 1
 */
var x;
console.log(x === undefined); // true
x = 3;

/**
 * Example 2
 */
var myvar = 'my value';

(function() {
  var myvar;
  console.log(myvar); // undefined
  myvar = 'local value';
})();
</pre>

<p>Because of hoisting, all <code>var</code> statements in a function should be placed as near to the top of the function as possible. This best practice increases the clarity of the code.</p>

<p>In ECMAScript 2015, <code>let</code> and <code>const</code> <strong>are hoisted but not initialized</strong>. Referencing the variable in the block before the variable declaration results in a {{jsxref("ReferenceError")}}, because the variable is in a "temporal dead zone" from the start of the block until the declaration is processed.</p>

<pre class="brush: js notranslate">console.log(x); // ReferenceError
let x = 3;</pre>

<h3 id="Function_hoisting">Function hoisting</h3>

<p>In the case of functions, only function <em>declarations</em> are hoisted—but <em>not</em> the function <em>expressions</em>.</p>

<pre class="brush: js notranslate">/* Function declaration */

foo(); // "bar"

function foo() {
  console.log('bar');
}

/* Function expression */

baz(); // TypeError: baz is not a function

var baz = function() {
  console.log('bar2');
};
</pre>

<h3 id="Global_variables">Global variables</h3>

<p>Global variables are in fact properties of the <em>global object</em>.</p>

<p>In web pages, the global object is {{domxref("window")}}, so you can set and access global variables using the <code>window.<var>variable</var></code> syntax.</p>

<p>Consequently, you can access global variables declared in one window or frame from another window or frame by specifying the <code>window</code> or <code>frame</code> name. For example, if a variable called <code>phoneNumber</code> is declared in a document, you can refer to this variable from an <code>iframe</code> as <code>parent.phoneNumber</code>.</p>

<h3 id="Constants">Constants</h3>

<p>You can create a read-only, named constant with the {{jsxref("Statements/const", "const")}} keyword.</p>

<p>The syntax of a constant identifier is the same as any variable identifier: it must start with a letter, underscore, or dollar sign (<code>$</code>), and can contain alphabetic, numeric, or underscore characters.</p>

<pre class="brush: js notranslate">const PI = 3.14;
</pre>

<p>A constant cannot change value through assignment or be re-declared while the script is running. It must be initialized to a value.</p>

<p>The scope rules for constants are the same as those for <code>let</code> block-scope variables. If the <code>const</code> keyword is omitted, the identifier is assumed to represent a variable.</p>

<p>You cannot declare a constant with the same name as a function or variable in the same scope. For example:</p>

<pre class="brush: js notranslate">// THIS WILL CAUSE AN ERROR
function f() {};
const f = 5;

// THIS WILL CAUSE AN ERROR TOO
function f() {
  const g = 5;
  var g;

  //statements
}
</pre>

<p>However, the properties of objects assigned to constants are not protected, so the following statement is executed without problems.</p>

<pre class="brush: js notranslate">const MY_OBJECT = {'key': 'value'};
MY_OBJECT.key = 'otherValue';</pre>

<p>Also, the contents of an array are not protected, so the following statement is executed without problems.</p>

<pre class="brush: js notranslate">const MY_ARRAY = ['HTML','CSS'];
MY_ARRAY.push('JAVASCRIPT');
console.log(MY_ARRAY); //logs ['HTML','CSS','JAVASCRIPT'];
</pre>

<h2 id="Data_structures_and_types">Data structures and types</h2>

<h3 id="Data_types">Data types</h3>

<p>The latest ECMAScript standard defines eight data types:</p>

<ul>
 <li>Seven data types that are {{Glossary("Primitive", "primitives")}}:
  <ol>
   <li>{{Glossary("Boolean")}}. <code>true</code> and <code>false</code>.</li>
   <li>{{Glossary("null")}}. A special keyword denoting a null value. (Because JavaScript is case-sensitive, <code>null</code> is not the same as <code>Null</code>, <code>NULL</code>, or any other variant.)</li>
   <li>{{Glossary("undefined")}}. A top-level property whose value is not defined.</li>
   <li>{{Glossary("Number")}}. An integer or floating point number. For example: <code>42</code> or <code>3.14159</code>.</li>
   <li>{{Glossary("BigInt")}}. An integer with arbitrary precision. For example: <code>9007199254740992n</code>.</li>
   <li>{{Glossary("String")}}. A sequence of characters that represent a text value. For example: "Howdy"</li>
   <li>{{Glossary("Symbol")}} (new in ECMAScript 2015). A data type whose instances are unique and immutable.</li>
  </ol>
 </li>
 <li>and {{Glossary("Object")}}</li>
</ul>

<p>Although these data types are relatively few, they enable you to perform useful functions with your applications. {{jsxref("Object", "Objects", "", 1)}} and {{jsxref("Function", "functions", "", 1)}} are the other fundamental elements in the language. You can think of objects as named containers for values, and functions as procedures that your script can perform.</p>

<h3 id="Data_type_conversion">Data type conversion</h3>

<p>JavaScript is a <em>dynamically typed</em> language. This means you don't have to specify the data type of a variable when you declare it. It also means that data types are automatically converted as-needed during script execution.</p>

<p>So, for example, you could define a variable as follows:</p>

<pre class="brush: js notranslate">var answer = 42;
</pre>

<p>And later, you could assign the same variable a string value, for example:</p>

<pre class="brush: js notranslate">answer = 'Thanks for all the fish...';
</pre>

<p>Because JavaScript is dynamically typed, this assignment does not cause an error message.</p>

<h3 id="Numbers_and_the_operator">Numbers and the '+' operator</h3>

<p>In expressions involving numeric and string values with the <code>+</code> operator, JavaScript converts numeric values to strings. For example, consider the following statements:</p>

<pre class="brush: js notranslate">x = 'The answer is ' + 42 // "The answer is 42"
y = 42 + ' is the answer' // "42 is the answer"
</pre>

<p>With all other operators, JavaScript does <em>not</em> convert numeric values to strings. For example:</p>

<pre class="brush: js notranslate">'37' - 7 // 30
'37' + 7 // "377"
</pre>

<h3 id="Converting_strings_to_numbers">Converting strings to numbers</h3>

<p>In the case that a value representing a number is in memory as a string, there are methods for conversion.</p>

<ul>
 <li id="parseInt()_and_parseFloat()">{{jsxref("parseInt", "parseInt()")}}</li>
 <li>{{jsxref("parseFloat", "parseFloat()")}}</li>
</ul>

<p><code>parseInt</code> only returns whole numbers, so its use is diminished for decimals.</p>

<div class="notecard note">
<p>Additionally, a best practice for <code>parseInt</code> is to always include the <em>radix</em> parameter. The radix parameter is used to specify which numerical system is to be used.</p>
</div>

<pre class="brush: js notranslate">parseInt('101', 2) // 5</pre>

<p>An alternative method of retrieving a number from a string is with the <code>+</code> (unary plus) operator:</p>

<pre class="brush: js notranslate">'1.1' + '1.1' // '1.11.1'
(+'1.1') + (+'1.1') // 2.2
// Note: the parentheses are added for clarity, not required.</pre>

<h2 id="Literals">Literals</h2>

<p><em>Literals</em> represent values in JavaScript. These are fixed values—not variables—that you <em>literally</em> provide in your script. This section describes the following types of literals:</p>

<ul>
 <li><a href="#Array_literals">Array literals</a></li>
 <li><a href="#Boolean_literals">Boolean literals</a></li>
 <li><a href="#Floating-point_literals">Floating-point literals</a></li>
 <li><a href="#Numeric_literals">Numeric literals</a></li>
 <li><a href="#Object_literals">Object literals</a></li>
 <li><a href="#RegExp_literals">RegExp literals</a></li>
 <li><a href="#String_literals">String literals</a></li>
</ul>

<h3 id="Array_literals">Array literals</h3>

<p>An array literal is a list of zero or more expressions, each of which represents an array element, enclosed in square brackets (<code>[]</code>). When you create an array using an array literal, it is initialized with the specified values as its elements, and its <code>length</code> is set to the number of arguments specified.</p>

<p>The following example creates the <code>coffees</code> array with three elements and a <code>length</code> of three:</p>

<pre class="brush: js notranslate">let coffees = ['French Roast', 'Colombian', 'Kona'];
</pre>

<div class="note">
<p><strong>Note :</strong> An array literal is a type of <em>object initializer</em>. See <a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Using_object_initializers">Using Object Initializers</a>.</p>
</div>

<p>If an array is created using a literal in a top-level script, JavaScript interprets the array each time it evaluates the expression containing the array literal. In addition, a literal used in a function is created each time the function is called.</p>

<div class="notecard note">
<p><strong>Note:</strong> Array literals are also <code>Array</code> objects. See {{jsxref("Array")}} and <a href="/en-US/docs/Web/JavaScript/Guide/Indexed_collections">Indexed collections</a> for details on <code>Array</code> objects.</p>
</div>

<h4 id="Extra_commas_in_array_literals">Extra commas in array literals</h4>

<p>You do not have to specify all elements in an array literal. If you put two commas in a row, the array fills in the value <code>undefined</code> for the unspecified elements. The following example creates the <code>fish</code> array:</p>

<pre class="brush: js notranslate">let fish = ['Lion', , 'Angel'];
</pre>

<p>This array has two elements with values and one empty element:</p>

<ul>
 <li><code>fish[0]</code> is "Lion"</li>
 <li><code>fish[1]</code> is <code>undefined</code></li>
 <li><code>fish[2]</code> is "Angel"</li>
</ul>

<p>If you include a trailing comma at the end of the list of elements, the comma is ignored.</p>

<p>In the following example, the <code>length</code> of the array is three. There is no <code>myList[3]</code>. All other commas in the list indicate a new element.</p>

<div class="note">
<p><strong>Note :</strong> Trailing commas can create errors in older browser versions and it is a best practice to remove them.</p>
</div>

<pre class="brush: js notranslate">let myList = ['home', , 'school', ];
</pre>

<p>In the following example, the <code>length</code> of the array is four, and <code>myList[0]</code> and <code>myList[2]</code> are missing.</p>

<pre class="brush: js notranslate">let myList = [ ,'home', , 'school'];
</pre>

<p>In the following example, the <code>length</code> of the array is four, and <code>myList[1]</code> and <code>myList[3]</code> are missing. <strong>Only the last comma is ignored.</strong></p>

<pre class="brush: js notranslate">let myList = ['home', , 'school', , ];
</pre>

<p>Understanding the behavior of extra commas is important to understanding JavaScript as a language.</p>

<p>However, when writing your own code, you should explicitly declare the missing elements as <code>undefined</code>. Doing this increases your code's clarity and maintainability.</p>

<h3 id="Boolean_literals">Boolean literals</h3>

<p>The Boolean type has two literal values: <code>true</code> and <code>false</code>.</p>

<div class="notecard note">
<p><strong>Be careful:</strong> Do not confuse the primitive Boolean values <code>true</code> and <code>false</code> with the true and false values of the {{jsxref("Boolean")}} object.</p>

<p>The Boolean object is a wrapper around the primitive Boolean data type. See {{jsxref("Boolean")}} for more information.</p>
</div>

<h3 id="Numeric_literals">Numeric literals</h3>

<p>{{jsxref("Number")}} and {{jsxref("BigInt")}} types can be written in decimal (base 10), hexadecimal (base 16), octal (base 8) and binary (base 2).</p>

<ul>
 <li>A <em>decimal</em> numeric literal is a sequence of digits without a leading <code>0</code> (zero).</li>
 <li>A leading <code>0</code> (zero) on a numeric literal, or a leading <code>0o</code> (or <code>0O</code>) indicates it is in <em>octal</em>. Octal numerics can include only the digits <code>0</code>–<code>7</code>.</li>
 <li>A leading <code>0x</code> (or <code>0X</code>) indicates a <em>hexadecimal</em> numeric type. Hexadecimal numerics can include digits (<code>0</code>–<code>9</code>) and the letters <code>a</code>–<code>f</code> and <code>A</code>–<code>F</code>. (The case of a character does not change its value. Therefore: <code>0xa</code> = <code>0xA</code> = <code>10</code> and <code>0xf</code> = <code>0xF</code> = <code>15</code>.)</li>
 <li>
  <p>A leading <code>0b</code> (or <code>0B</code>) indicates a <em>binary</em> numeric literal. Binary numerics can only include the digits <code>0</code> and <code>1</code>.</p>
 </li>
</ul>

<p>Some examples of numeric literals are:</p>

<pre class="eval notranslate">0, 117, -345, 123456789123456789n             (decimal, base 10)
015, 0001, -0o77, 0o777777777777n             (octal, base 8)
0x1123, 0x00111, -0xF1A7, 0x123456789ABCDEFn  (hexadecimal, "hex" or base 16)
0b11, 0b0011, -0b11, 0b11101001010101010101n  (binary, base 2)
</pre>

<p>For more information, see <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Numeric_literals">Numeric literals in the Lexical grammar reference</a>.</p>

<h3 id="Floating-point_literals">Floating-point literals</h3>

<p>A floating-point literal can have the following parts:</p>

<ul>
 <li>A decimal integer which can be signed (preceded by "<code>+</code>" or "<code>-</code>"),</li>
 <li>A decimal point ("<code>.</code>"),</li>
 <li>A fraction (another decimal number),</li>
 <li>An exponent.</li>
</ul>

<p>The exponent part is an "<code>e</code>" or "<code>E</code>" followed by an integer, which can be signed (preceded by "<code>+</code>" or "<code>-</code>"). A floating-point literal must have at least one digit, and either a decimal point or "<code>e</code>" (or "<code>E</code>").</p>

<p>More succinctly, the syntax is:</p>

<pre class="eval notranslate">[(+|-)][digits].[digits][(E|e)[(+|-)]digits]
</pre>

<p>For example:</p>

<pre class="eval notranslate">3.1415926
-.123456789
-3.1E+12
.1e-23
</pre>

<h3 id="Object_literals">Object literals</h3>

<p>An object literal is a list of zero or more pairs of property names and associated values of an object, enclosed in curly braces (<code>{}</code>).</p>

<div class="notecard warning">
<p><strong>Do not use an object literal at the beginning of a statement! </strong>This will lead to an error (or not behave as you expect), because the <code>{</code> will be interpreted as the beginning of a block.</p>
</div>

<p>The following is an example of an object literal. The first element of the <code>car</code> object defines a property, <code>myCar</code>, and assigns to it a new string, "<code>Saturn</code>"; the second element, the <code>getCar</code> property, is immediately assigned the result of invoking the function <code>(carTypes("Honda"));</code> the third element, the <code>special</code> property, uses an existing variable (<code>sales</code>).</p>

<pre class="brush: js notranslate">var sales = 'Toyota';

function carTypes(name) {
  if (name === 'Honda') {
    return name;
  } else {
    return "Sorry, we don't sell " + name + ".";
  }
}

var car = { myCar: 'Saturn', getCar: carTypes('Honda'), special: sales };

console.log(car.myCar);   // Saturn
console.log(car.getCar);  // Honda
console.log(car.special); // Toyota
</pre>

<p>Additionally, you can use a numeric or string literal for the name of a property or nest an object inside another. The following example uses these options.</p>

<pre class="brush: js notranslate">var car = { manyCars: {a: 'Saab', b: 'Jeep'}, 7: 'Mazda' };

console.log(car.manyCars.b); // Jeep
console.log(car[7]); // Mazda
</pre>

<p>Object property names can be any string, including the empty string. If the property name would not be a valid JavaScript {{Glossary("Identifier","identifier")}} or number, it must be enclosed in quotes.</p>

<p>Property names that are not valid identifiers cannot be accessed as a dot (<code>.</code>) property, but <em>can</em> be accessed and set with the array-like notation("<code>[]</code>").</p>

<pre class="brush: js notranslate">var unusualPropertyNames = {
  '': 'An empty string',
  '!': 'Bang!'
}
console.log(unusualPropertyNames.'');   // SyntaxError: Unexpected string
console.log(unusualPropertyNames['']);  // An empty string
console.log(unusualPropertyNames.!);    // SyntaxError: Unexpected token !
console.log(unusualPropertyNames['!']); // Bang!</pre>

<h4 id="Enhanced_Object_literals">Enhanced Object literals</h4>

<p>In ES2015, object literals are extended to support setting the prototype at construction, shorthand for <code>foo: foo</code> assignments, defining methods, making <code>super</code> calls, and computing property names with expressions.</p>

<p>Together, these also bring object literals and class declarations closer together, and allow object-based design to benefit from some of the same conveniences.</p>

<pre class="brush: js notranslate">var obj = {
    // __proto__
    __proto__: theProtoObj,
    // Shorthand for ‘handler: handler’
    handler,
    // Methods
    toString() {
     // Super calls
     return 'd ' + super.toString();
    },
    // Computed (dynamic) property names
    [ 'prop_' + (() =&gt; 42)() ]: 42
};
</pre>

<h3 id="RegExp_literals">RegExp literals</h3>

<p>A regex literal (which is defined in detail <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">later</a>) is a pattern enclosed between slashes. The following is an example of a regex literal.</p>

<pre class="brush: js notranslate">var re = /ab+c/;</pre>

<h3 id="String_literals">String literals</h3>

<p>A string literal is zero or more characters enclosed in double (<code>"</code>) or single (<code>'</code>) quotation marks. A string must be delimited by quotation marks of the same type (that is, either both single quotation marks, or both double quotation marks).</p>

<p>The following are examples of string literals:</p>

<pre class="brush: js notranslate">'foo'
"bar"
'1234'
'one line \n another line'
"John's cat"
</pre>

<p>You can call any of the {{jsxref("String")}} object's methods on a string literal value. JavaScript automatically converts the string literal to a temporary String object, calls the method, then discards the temporary String object. You can also use the <code>String.length</code> property with a string literal:</p>

<pre class="brush: js notranslate">// Will print the number of symbols in the string including whitespace.
console.log("John's cat".length)  // In this case, 10.
</pre>

<p>In ES2015, <em>template literals</em> are also available. Template literals are enclosed by the back-tick (<code>`</code>) (<a class="external external-icon" href="https://en.wikipedia.org/wiki/Grave_accent" rel="noopener">grave accent</a>) character instead of double or single quotes.</p>

<p>Template strings provide syntactic sugar for constructing strings. (This is similar to string interpolation features in Perl, Python, and more.)</p>

<p>Optionally, a tag can be added to allow the string construction to be customized, avoiding injection attacks, or constructing higher-level data structures from string contents.</p>

<pre class="brush: js notranslate">// Basic literal string creation
`In JavaScript '\n' is a line-feed.`

// Multiline strings
`In JavaScript, template strings can run
 over multiple lines, but double and single
 quoted strings cannot.`

// String interpolation
var name = 'Bob', time = 'today';
`Hello ${name}, how are you ${time}?`

// Construct an HTTP request prefix used to interpret the replacements and construction
POST`http://foo.org/bar?a=${a}&amp;b=${b}
     Content-Type: application/json
     X-Credentials: ${credentials}
     { "foo": ${foo},
       "bar": ${bar}}`(myOnReadyStateChangeHandler);</pre>

<p>You should use string literals unless you specifically need to use a <code>String</code> object. See {{jsxref("String")}} for details on <code>String</code> objects.</p>

<h4 id="Using_special_characters_in_strings">Using special characters in strings</h4>

<p>In addition to ordinary characters, you can also include special characters in strings, as shown in the following example.</p>

<pre class="brush: js notranslate">'one line \n another line'
</pre>

<p>The following table lists the special characters that you can use in JavaScript strings.</p>

<table class="standard-table">
 <caption>Table: JavaScript special characters</caption>
 <thead>
  <tr>
   <th scope="col">Character</th>
   <th scope="col">Meaning</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>\0</code></td>
   <td>Null Byte</td>
  </tr>
  <tr>
   <td><code>\b</code></td>
   <td>Backspace</td>
  </tr>
  <tr>
   <td><code>\f</code></td>
   <td>Form feed</td>
  </tr>
  <tr>
   <td><code>\n</code></td>
   <td>New line</td>
  </tr>
  <tr>
   <td><code>\r</code></td>
   <td>Carriage return</td>
  </tr>
  <tr>
   <td><code>\t</code></td>
   <td>Tab</td>
  </tr>
  <tr>
   <td><code>\v</code></td>
   <td>Vertical tab</td>
  </tr>
  <tr>
   <td><code>\'</code></td>
   <td>Apostrophe or single quote</td>
  </tr>
  <tr>
   <td><code>\"</code></td>
   <td>Double quote</td>
  </tr>
  <tr>
   <td><code>\\</code></td>
   <td>Backslash character</td>
  </tr>
  <tr>
   <td><code>\<em>XXX</em></code></td>
   <td>The character with the Latin-1 encoding specified by up to three octal digits <em>XXX</em> between <code>0</code> and <code>377</code>.<br>
    For example, <code>\251</code> is the octal sequence for the copyright symbol.</td>
  </tr>
  <tr>
  </tr>
  <tr>
   <td><code>\x<em>XX</em></code></td>
   <td>
    <p>The character with the Latin-1 encoding specified by the two hexadecimal digits <em>XX</em> between <code>00</code> and <code>FF</code>.<br>
     For example, <code>\xA9</code> is the hexadecimal sequence for the copyright symbol.</p>
   </td>
  </tr>
  <tr>
  </tr>
  <tr>
   <td><code>\u<em>XXXX</em></code></td>
   <td>The Unicode character specified by the four hexadecimal digits <em>XXXX</em>.<br>
    For example, <code>\u00A9</code> is the Unicode sequence for the copyright symbol. See <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#String_literals">Unicode escape sequences</a>.</td>
  </tr>
  <tr>
   <td><code>\u<em>{XXXXX}</em></code></td>
   <td>Unicode code point escapes.<br>
    For example, <code>\u{2F804}</code> is the same as the simple Unicode escapes <code>\uD87E\uDC04</code>.</td>
  </tr>
 </tbody>
</table>

<h4 id="Escaping_characters">Escaping characters</h4>

<p>For characters not listed in the table, a preceding backslash is ignored, but this usage is deprecated and should be avoided.</p>

<p>You can insert a quotation mark inside a string by preceding it with a backslash. This is known as <em>escaping</em> the quotation mark. For example:</p>

<pre class="brush: js notranslate">var quote = "He read \"The Cremation of Sam McGee\" by R.W. Service.";
console.log(quote);
</pre>

<p>The result of this would be:</p>

<pre class="eval notranslate">He read "The Cremation of Sam McGee" by R.W. Service.
</pre>

<p>To include a literal backslash inside a string, you must escape the backslash character. For example, to assign the file path <code>c:\temp</code> to a string, use the following:</p>

<pre class="brush: js notranslate">var home = 'c:\\temp';
</pre>

<p>You can also escape line breaks by preceding them with backslash. The backslash and line break are both removed from the value of the string.</p>

<pre class="brush: js notranslate">var str = 'this string \
is broken \
across multiple \
lines.'
console.log(str);   // this string is broken across multiple lines.
</pre>

<p>Although JavaScript does not have "heredoc" syntax, you can get close by adding a line break escape and an escaped line break at the end of each line:</p>

<pre class="brush: js notranslate">var poem =
'Roses are red,\n\
Violets are blue.\n\
Sugar is sweet,\n\
and so is foo.'
</pre>

<p>ECMAScript 2015 introduces a new type of literal, namely <a href="/en-US/docs/Web/JavaScript/Reference/template_strings"><strong>template literals</strong></a>. This allows for many new features, including multiline strings!</p>

<pre class="brush: js notranslate">var poem =
`Roses are red,
Violets are blue.
Sugar is sweet,
and so is foo.` </pre>

<h2 id="More_information">More information</h2>

<p>This chapter focuses on basic syntax for declarations and types. To learn more about JavaScript's language constructs, see also the following chapters in this guide:</p>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Control_flow_and_error_handling">Control flow and error handling</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Loops_and_iteration">Loops and iteration</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions">Functions</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators">Expressions and operators</a></li>
</ul>

<p>In the next chapter, we will have a look at control flow constructs and error handling.</p>

<p>{{PreviousNext("Web/JavaScript/Guide/Introduction", "Web/JavaScript/Guide/Control_flow_and_error_handling")}}</p>
